package ch.inf3.horizoncut.data;

import org.junit.Assert;
import org.junit.Test;

public class PositionTest {
    private static final double TOLERANCE = 0.000833;

    @Test
    public void testBearingEast01() {
        Position a = new Position(46.0341763, 7.6119305);
        Position b = Position.get(a, Math.PI/2, 5_000);

        Assert.assertEquals(46.034158, b.getLatitude(), TOLERANCE);
        Assert.assertEquals(7.676710, b.getLongitude(), TOLERANCE);
    }

    @Test
    public void testBearingEast02() {
        Position a = new Position(46.0341763, 7.6119305);
        Position b = Position.get(a, Math.PI/2, 50_000);

        Assert.assertEquals(46.032346, b.getLatitude(), TOLERANCE);
        Assert.assertEquals(8.259716, b.getLongitude(), TOLERANCE);
    }

    @Test
    public void testBearing() {
        Position a = new Position(46.0341763, 7.6119305);

        for(int i = 0; i < 360; i++) {

            Position b = Position.get(a, Math.toRadians(i), 10000);
            double bearing = Position.bearing(a, b);

            Assert.assertEquals(i, Math.toDegrees(bearing), 0.1);
        }
    }

}
